// -*-c++-*-

/***************************************************************************
                                 rcclexer.h
                         Lexer for RoboCup language
                             -------------------
    begin                : 24-JUNE-2002
    copyright            : (C) 2002 by Tom Howard
    email                : tomhoward@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/

#ifndef RCCLEXER_H
#define RCCLEXER_H

#undef yyFlexLexer
#define yyFlexLexer RCCFlexLexer
#include <rcssbase/FlexLexer.h>

#include <string>

#include "rccparser.h"

class RCCLexer
  : public yyFlexLexer
{
public:
    typedef rcc::Holder Holder;

    virtual
    int
    yylex();

    inline
    int
    lex( Holder& holder )
    { M_lexed_val = &holder; return yylex(); }
private:
    Holder* M_lexed_val;
};

namespace rcc
{
    class Lexer
        : public RCCLexer
    {
    };
}

#endif
