// -*-c++-*-

/***************************************************************************
                               rccparser.cpp
                          Parser Abstract Base Class
                             -------------------
    begin                : 22-MAR-2003
    copyright            : (C) 2003 by Tom Howard
    email                : tomhoward@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU GPL as published by the Free Software   *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/


#include "rccparser.h"
#include "rcclexer.h"
#include <algorithm>

namespace rcc
{
    Parser::Param::Param( Parser& parser )
        : M_parser( parser ),
          M_lexer( new rcc::Lexer )
    {}

    Parser::Param::~Param()
    { delete M_lexer; }

    Parser::Param::Param( const Param& param )
        : M_parser( param.M_parser ),
          M_lexer( new rcc::Lexer( *( param.M_lexer ) ) )
    {}
    
    Parser::Param&
    Parser::Param::operator=( const Parser::Param& param )
    {
        Parser::Param tmp( param );
        std::swap( tmp, *this );
        return *this;
    }

    bool
    Parser::setStream( std::istream& strm )
    { M_param.getLexer().switch_streams( &strm, &std::cerr );  return true; }
}
